<script>
  import { json } from "d3-fetch";
  import { onMount } from "svelte";
  import { scaleLinear } from 'd3-scale';
  import { max } from 'd3-array';

  // Load data
  let alldata3 = [];
  onMount(async () => {
    alldata3 = await json('/data/hourly_electricity_vs_gas_december.json');
  })

  const weekslist_right = ["48", "50", "52"];
  const weekslist_left = ["49", "51"];

  const transformdata3 = (dataset) => {
    let transformed = {};
    dataset.forEach((d) => {
      if ( !(d.week in transformed)) {
          transformed[d.week] = {"electricity": [], "gas": []}
      }
      transformed[d.week]["electricity"].push(d.total_electrity);
      transformed[d.week]["gas"].push(d.total_gas)
    })
    return transformed
  }

  // Size and margins
  const width = 500;
  const height = 600;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  const weekWidth = innerWidth/2;
  const weekHeight = innerHeight/15;

  // Scales
  $: xScale = scaleLinear().domain([1, 168]).range([0, weekWidth])
  $: yScale_ele = scaleLinear().domain([0, max(alldata3.map((d) => d.total_electrity))]).range([weekHeight, 0])
  $: yScale_gas = scaleLinear().domain([0, max(alldata3.map((d) => d.total_gas))]).range([weekHeight, 0])

  let pathGenerator = (d, yscale) => {
        let path = "M 0," + yscale(0);
        d.forEach((value, idx) => {
            path += " " + xScale(idx+1) + "," + yscale(value)
            if (idx+1==d.length) {
              path += " " + xScale(idx+1) + "," + yscale(0);
            }
        })
        return path;
    }
</script>

{#if alldata3.length == 0}
  <p>Loading the data, please wait...</p>
{:else}
<svg {width} {height}>
  <g transform="translate({margin.left}, {margin.top})">
    <!--  -->
    <line x1={innerWidth/2} x2={innerWidth/2} y1={innerHeight} y2=35 stroke="black"/>
    {#each weekslist_right as week,idx}
      <g transform="translate({innerWidth/2-weekHeight/2+10}, {(3-idx)*innerHeight/3-weekHeight}) rotate(-30)">
        <path d={pathGenerator(transformdata3(alldata3)[week]["electricity"], yScale_ele)} class="ele"/>
        <g transform="translate(0,{2*weekHeight+1}) scale(1,-1)">
          <path d={pathGenerator(transformdata3(alldata3)[week]["gas"], yScale_gas)} class="gas"/>
        </g>
        <line x1=-10 x2={weekWidth+10} y1={weekHeight} y2={weekHeight} stroke="black" stroke-width="0.5"  />
      </g>
    {/each}

    {#each weekslist_left as week,idx}
    <g transform="translate({innerWidth/2-weekHeight/2+30}, {(5-idx*2)*innerHeight/6-weekHeight}) scale(-1,1) rotate(-30)">
      <path d={pathGenerator(transformdata3(alldata3)[week]["electricity"], yScale_ele)} class="ele"/>
      <g transform="translate(0,{2*weekHeight+1}) scale(1,-1)">
        <path d={pathGenerator(transformdata3(alldata3)[week]["gas"], yScale_gas)} class="gas"/>
      </g>
      <line x1=-10 x2={weekWidth+10} y1={weekHeight} y2={weekHeight} stroke="black" stroke-width="0.5"  />
    </g>
    {/each}

    <text x={innerWidth/2} y=20>Baltimore - December 2014</text>
  </g>
</svg>
{/if}

<style>
  svg {
    border: 1px solid black;
    border-radius: 5px;
  }
  .ele {
    stroke: blue;
    fill: blue; 
  }
  .gas {
    stroke: orange;
    fill: orange;
  }
  text {
    font-size: medium;
    font-weight: bold;
    text-anchor: middle;
  }
</style>
